package java_sound_complete;

import javax.sound.sampled.*;
import java.io.*;

class MikroAufnahme extends Thread {
    static AudioInputStream stream = null;
    static AudioFormat neuesFormat;
    static byte[] ba = null;
    static int AnzahlGelBytes = 0;
    static boolean aufnahme = true;
    static TargetDataLine targetLine_1 = null;
    static ByteArrayOutputStream baOut = null;
    static DataLine.Info info;//, info2;
    static FloatControl gainControl;
    
    public MikroAufnahme() {
        
        // Audioformat festlegen: Samplerate 11025 Hz, 16 Bit, signed, little-endian
        
        neuesFormat = new AudioFormat((float) 11025.0, 16, 2, true, false);
        
        
        info = new DataLine.Info(TargetDataLine.class, neuesFormat); //fr Aufnahme

        try {
            //Source und Target DataLine erzeugen
            targetLine_1 = (TargetDataLine) AudioSystem.getLine(info);
        } catch (LineUnavailableException e) {
            System.out.println("MikroAufnahme: Keine TargetDataLine/SourceDataLine frei");
            System.exit(1);
        }
        
        
        
        try {
            //DataLines ffnen
            targetLine_1.open();
        } catch (LineUnavailableException e) {
            System.out.println("MikroAufnahme: TargetDataLine konnte nicht geffnet werden");
            System.exit(1);
        }
        
    }
    
    public void run() {
        
        //neuen ByteArrayOutputStream erzeugen und baOut zuweisen
        baOut = new ByteArrayOutputStream();
        
        int AnzahlGelBytes = 0;
        
        //Buffer in das aufgenommene Daten eingelesen werden
        ba = new byte[64];
        
        //Starten der Line zum Aufnehmen des Sounds (Target)
        targetLine_1.start();
             
        
        while (aufnahme) {
            //lese Sounddaten in buffer ein von Target
            AnzahlGelBytes = targetLine_1.read(ba, 0, ba.length);
                        
            //Schreibe Daten in Stream 
            baOut.write(ba, 0, AnzahlGelBytes);
        }
        
        //targetLine leeren
        targetLine_1.drain();
        
        //targetLine anhalten
        targetLine_1.stop();
        
        //targetLine schlieen
        targetLine_1.close();
    }
    
    
    
}

